<%@ LANGUAGE="VBScript" %>
<%

'###########################################################################
'#
'# Example ASP Script for Saving Screenshot Data from NESCafe Applet
'#
'# @author  : David de Niese
'# @version : 0.57f
'#
'# The Screen Shots are saved in Native Format into screenshot folder
'#
'###########################################################################


'### Enable Explicit Variable Declaration

	Option Explicit



'####################################################################################################
'#
'# Function to Create a Directory
'#
'####################################################################################################

	Sub CreateFolder(path) 


		'### Declare Local Variables

			Dim oFS   
			Dim oFSFolder   


		'### Create File System Object
   
			Set oFS = Server.CreateObject("Scripting.FileSystemObject") 


		'### Check if Already Exists

			If oFS.FolderExists(path) Then 

				Set oFS = Nothing 
				Exit Sub 

			End If 
   

		'### Attempt to Create the Directory

			Set oFSFolder = oFS.CreateFolder(path) 
  

		'### Destroy Objects
   
			Set oFSFolder = Nothing 
			Set oFS = Nothing 


	End Sub 



'####################################################################################################
'#
'# Main Routine
'#
'####################################################################################################



'### Force Expiring Responses

	Response.Expires=-1


'### Declare Variables

	Dim BankData
	Dim i


'### Grab the Number of Hex Values to Read from the Data Stream

	Dim dl
	dl = Request.Form("datalength") + 0


'### Grab the Name of the Game Loaded into NESCafe

	Dim gamename
	gamename = Request.Form("gamename")
	If gamename = "" Then gamename = "unknown"


'### Turn on Error Detection

	On Error Resume Next


'### Ensure Directory Exists

	Call CreateFolder(Server.MapPath("screenshot"))


'### Create the File to Save the SaveRAM Into using the GameName

	Dim ofs
	Set ofs = Server.CreateObject("Scripting.FileSystemObject")

	Dim otf
	Set otf = ofs.OpenTextFile(Server.MapPath("screenshot\" & gamename & ".pixeldata"),2,True)


'### Check for Errors

	If Err.Number <> 0 Then Response.End
	On Error Goto 0


'### I is used to hold the Current Bank Number that is being read

	I = 0


'### Total is the total number of Hex Bytes Read (which should match DataLength)

	Dim total
	total = 0


'### Loop Over the Data

	BankData = Request.Form("data" & I)

	While BankData <> ""


		'### Store Data in File

			otf.WriteLine BankData



		'### Increment Total Number of Bytes Read

			total  = total  + len(BankData)



		'### Increment Bank Number

			I = I + 1


		'### Read from Next Bank

			BankData = Request.Form("data" & I)

	Wend



'### Close File

	otf.close



'### Check Totals Match

	If dl <> total  Then

		Response.Write "Bad Bank Data Length : " & total  & ":" & dl
		Response.End

	End if


'### Broadcast Success Message Back, with Carriage Return and Newline
	
	Response.Write "Success : " & I & Chr(13) & Chr(10)
	Response.End

%>